require "itkrt2y/version"

module Itkrt2y
  def all
    methods = Itkrt2y::methods(false) - [:all, :to_s]
    methods.map { |method| Itkrt2y.send(method) }
  end

  def name
    {
      full_name: { title: "氏名", value: "板倉 達也" },
      furigana: { title: "ふりがな", value: "いたくら たつや" }
    }
  end

  def email
    { email: { title: "メールアドレス", value: "itkrt2y.591721200@gmail.com" } }
  end

  def education
    {
      junior_high_school: {
        title: "中学",
        name: "私立桐光学園中学校",
        entrance: "2001年4月入学",
        end: "2004年3月卒業"
      },
      high_school: {
        title: "高校",
        name: "私立桐光学園高等学校",
        entrance: "2004年4月入学",
        end: "2007年3月卒業"
      },
      college: {
        title: "大学",
        name: "東京農工大学",
        faculty: "農学部",
        department: "地域生態システム学科",
        entrance: "2008年4月入学",
        end: "2013年3月卒業"
      }
    }
  end

  def to_s(data_type = :all)
    data_params = Itkrt2y.send(data_type)

    string_data =
      case data_params
      when Array
        data_params.map do |params|
          format_hash(params)
        end
      when Hash
        format_hash(data_params)
      else
        puts "指定した型が間違っています"
      end

    string_data
  end

  module_function :all, :name, :email, :education, :to_s

  def self.format_hash(params)
    params.map do |key, val|
      data_keys = (val.keys - [:title])
      data = data_keys.map { |k| val[k] }.join(" ")
      "#{val[:title]} : #{data}\n"
    end
  end

  private_class_method :format_hash
end
